const saplingBlocks = [
  {
    blockID: "md_wardens:bloombelle",
    maxStage: 3,
    growChance: {
      numerator: 1,
      denominator: 3
    }
  }
];
const sapSet = new Set([
  "md_wardens:bloombelle"
]);

export const randomTickComponent = {
  onRandomTick(e) {
    const { block } = e;
    
    if (sapSet.has(block.typeId)) {
      handleSaplingGrowth(block);
    } 
  }
};

function randomNum(min, max) {
  //return a random number
  return Math.random() * (max - min) + min;
}

function handleSaplingGrowth(block) {
  const data = saplingBlocks.find((f) => f.blockID === block.typeId);
  if (!data) return;

  const stage = getGrowthStage(block);
  if (stage >= data.maxStage) return;

  const num = randomNum(0, data.growChance.denominator);
  if (num > data.growChance.numerator) return;

  const newStage = stage + 1;
  block.setPermutation(block.permutation.withState("maca:growth_stage", newStage));
}

function getGrowthStage(block) {
  // Assuming the growth state ID is "maca:growth_stage"
  return block.permutation.getState("maca:growth_stage") || 0;
}
